#include "Angle.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// l^Đ [ Constructor ]
Angle::Angle( double angle ) :
    m_angle( angle )
{
}

/// l^Đ [ Constructor ]
Angle::Angle( System::Decimal angle ) :
    m_angle( Decimal::ToDouble( angle ) )
{
}

/// XML琶 [ Constructor ]
Angle::Angle( System::Xml::XmlElement^ element )
{
    if( element != nullptr )
    {
        // LȗvfȂ΁A擾
        double value = Double::Parse( element->GetAttribute( "initial" ) );

        // ... Radian ɕϊĐݒ肷
        m_angle = CalculateRadian( value );
    }
    else
    {
        m_angle = 0.0;
    }
}


/// 𔽓]ĕԂ [ Operator Overloading ]
Angle Angle::operator-()
{
    return Angle( -m_angle );
}


/// Zq == [ Operator Overloading ]
bool Angle::operator==( Angle% left, Angle% right )
{
    // x vZ@CvVƂĔr
    return left.Equals( right, Double::Epsilon );
}

/// sZq != [ Operator Overloading ]
bool Angle::operator!=( Angle% left, Angle% right )
{
    // Z̔ےԂ
    return !( left == right );
}

/// l̓mF
bool Angle::Equals( Angle% obj )
{
    // x vZ@CvVƂĔr
    return Equals( obj, Double::Epsilon );
}

/// l̓mF
bool Angle::Equals( Angle% obj, double precision )
{
    // ̐Βl߂
    double remainder = Math::Abs( m_angle - obj.m_angle );

    // ... ꂪw肳ꂽxȉȂ΁AƂ݂Ȃ
    return ( remainder <= precision );
}


/// a += [ Operator Overloading ]
Angle Angle::operator+=( double value )
{
    m_angle += value;

    return *this;
}

///  -= [ Operator Overloading ]
Angle Angle::operator-=( double value )
{
    m_angle -= value;

    return *this;
}


///  *= [ Operator Overloading ]
Angle Angle::operator*=( double value )
{
    m_angle *= value;

    return *this;
}

///  /= [ Operator Overloading ]
Angle Angle::operator/=( double value )
{
    m_angle /= value;

    return *this;
}


/// a + [ Operator Overloading ]
Angle Angle::operator+( Angle% obj, double value )
{
    Angle result( obj );
    result += value;

    return result;
}

/// a + [ Operator Overloading ]
Angle Angle::operator+( double value, Angle% obj )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    return( obj + value );
}

/// a + [ Operator Overloading ]
Angle Angle::operator+( Angle% left, Angle% right )
{
    Angle result( left );
    result += right;

    return result;
}


///  - [ Operator Overloading ]
Angle Angle::operator-( Angle% obj, double value )
{
    Angle result( obj );
    result -= value;

    return result;
}

///  - [ Operator Overloading ]
Angle Angle::operator-( double value, Angle% obj )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    Angle result( obj - value );

    // ... 𔽓]ĕԂ
    return( -result );
}

///  - [ Operator Overloading ]
Angle Angle::operator-( Angle% left, Angle% right )
{
    Angle result( left );
    result -= right;

    return result;
}


/// gɋ߂Ԃ
Angle% Angle::Near( Angle% reference1, Angle% reference2 )
{
    // QƂ邻ꂼɂāAgƂ̍߂
    double difference1 = Math::Abs( reference1.m_angle - m_angle );
    double difference2 = Math::Abs( reference2.m_angle - m_angle );

    // ... قԂ
    return( difference1 < difference2 )? reference1 : reference2;
}


/// Radian ŕ\Ă邩H
bool Angle::IsExpressedByRadian( double angle )
{
    return ( angle >= -Math::PI )
        && ( angle <= +Math::PI );
}


/// Radian Degree ߂
double Angle::CalculateDegree( double radian )
{
    return radian * ( 180.0 / Math::PI );
}

/// Degree Radian ߂
double Angle::CalculateRadian( double degree )
{
    return degree * ( Math::PI / 180.0 );
}

/// Degree Radian ߂
double Angle::CalculateRadian( System::Decimal degree )
{
    // double^Ŏ擾 ֐Ăяo
    return CalculateRadian( Decimal::ToDouble( degree ) );
}


/// CX^X̐𕶎ŕԂ
System::String^ Angle::ToString()
{
    return Degree.ToString( "0.0" );
}