#include "AngleRange.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// [ Constructor ]
AngleRange::AngleRange( double minimum, double maximum ) :
    m_minimum( Angle( minimum ) ),
    m_maximum( Angle( maximum ) )
{
}

/// [ Constructor ]
AngleRange::AngleRange( Angle minimum, Angle maximum ) :
    m_minimum( minimum ),
    m_maximum( maximum )
{
}


/// Zq == [ Operator Overloading ]
bool AngleRange::operator==( AngleRange% left, AngleRange% right )
{
    return ( left.m_minimum == right.m_minimum )
        && ( left.m_maximum == right.m_maximum );
}

/// sZq != [ Operator Overloading ]
bool AngleRange::operator!=( AngleRange% left, AngleRange% right )
{
    // Z̔ےԂ
    return !( left == right );
}


/// ͈͓ɂ邩H
bool AngleRange::IsWithinRange( Angle val )
{
    return ( m_minimum <= val ) && ( val <= m_maximum );
}


/// ͈͂g
void AngleRange::ExpandRange( Angle value )
{
    if( m_maximum < value )
    {
        // 傫Ȃ΁Aɐݒ肷
        m_maximum = value;
    }

    if( value < m_minimum )
    {
        // 菬Ȃ΁Aɐݒ肷
        m_minimum = value;
    }
}


/// CX^X̐𕶎ŕԂ
System::String^ AngleRange::ToString()
{
    return String::Format( "{0} {1}", m_minimum, m_maximum );
}