#include "AxisVector.h"


#include "Matrix.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// 琶 [ Constructor ]
AxisVector::AxisVector( double x, double y, double z ) :
    Vector( DefaultDimension )
{
    this[ 1 ] = x;
    this[ 2 ] = y;
    this[ 3 ] = z;

    Debug::Assert( IsUnitVector( Precision ), "PʃxNgł" );
}

/// xNg琶(mF邽߂ɁAI[o[ChĂ) [ Constructor ]
AxisVector::AxisVector( Vector^ vector ) :
    Vector( vector )
{
    Debug::Assert( Dimension == DefaultDimension, "̎ł" );
    Debug::Assert( IsUnitVector( Precision ), "PʃxNgł" );
}

/// XML琶 [ Constructor ]
AxisVector::AxisVector( System::Xml::XmlElement^ element ) :
    Vector( DefaultDimension )
{
    Debug::Assert( element != nullptr, "Lȗvfł" );


    // ݒ肷
    this[ 1 ] = Double::Parse( element->GetAttribute( "x" ) );
    this[ 2 ] = Double::Parse( element->GetAttribute( "y" ) );
    this[ 3 ] = Double::Parse( element->GetAttribute( "z" ) );

    Debug::Assert( IsUnitVector( Precision ), "PʃxNgł" );
}


/// 
AxisVector^ AxisVector::Create( System::Xml::XmlElement^ element )
{
    Xml::XmlElement^ node = element[ "axisVector" ];

    if( node == nullptr )
    {
        // vf݂ȂȂ΁AkԂ
        return nullptr;
    }


    // ĕԂ
    return gcnew AxisVector( node );
}


/// txNgԂ [ Operator Overloading ]
AxisVector^ AxisVector::operator-()
{
    return gcnew AxisVector( -1.0 * this );

    /// @note \LɂȂ邽߁A{NXI[o[ChĂȂ
}

///  * (xNg]) [ Operator Overloading ]
AxisVector^ AxisVector::operator*( Matrix^ rotationMatrix, AxisVector^ axisVector )
{
    // xNgɃLXg
    Vector^ vector = safe_cast< Vector^ >( axisVector );

    // ... sƃxNg̐ςƂċ߂
    AxisVector^ result = gcnew AxisVector( rotationMatrix * vector );
    return result;
}


/// CX^X̐𕶎ŕԂ
String^ AxisVector::ToString()
{
    return String::Format( "{0:0.000} {1:0.000} {2:0.000}", X, Y, Z );
}