#include "Geometry.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// OnXL (ʕ߂)
Points^ Geometry::GrahamScan( Points^ vertices )
{
    int vertexSum = vertices->Length;   // _
    Debug::Assert( 3 <= vertexSum, "_͂Rȏł (ȂΑp`ƂȂ蓾Ȃ)" );

    Geometry^ geometry = gcnew Geometry();


    // Zp _̔z𐶐
    Points^ result = gcnew Points( vertexSum + 1 );

    // ... z̑O󂯂悤ɃRs[
    Array::Copy(
        vertices,   // Rs[
        0,          // Rs[JnCfbNX
        result,     // Rs[
        1,          // i[JnCfbNX
        vertexSum   // Rs[vf̐
    );


    // YɍŏAXɍőƂȂ_̃CfbNX擾
    int pointInCorner = geometry->GetIndexOfPointInCorner( result );

    // ... ̓_ ŏ̓_
    Point::Swap( result[ pointInCorner ], result[ 1 ] );


    // pxWi[z𐶐
    array< double >^ comparisonOfAngle = gcnew array< double >( vertexSum + 1 );

    for( int i=1; i<=vertexSum; i++ )
    {
        // px̊Ԃ̑召֌W̔sW擾
        comparisonOfAngle[ i ] = geometry->GetCoefficientComparisonOfAngle( result[ 1 ], result[ i ] );
    }

    // ... ߂pxWɏ] _̔z\[g
    geometry->QuickSort(
        1,                  // Ԃ̍[
        vertexSum,          // Ԃ̉E[
        comparisonOfAngle,  // \[g̊ƂȂ
        result              // \[g
        );


    Debug::Assert( result[ 0 ] == Point( 0.0, 0.0 ), "vf[̒_͏ĂȂ" );

    // ŏ̒_ Ō̒_
    result[ 0 ] = result[ vertexSum ];


    int count = 2;  // ʕȂĂ(IĂ)_

    /// @note ƂȂ钸_́Aŏ珈IĂƂ݂Ȃ


    // ʕ`
    for( int i=3; i<=vertexSum; i++ )
    {
        // R_̂ȂpxɂȂ܂łԂāAׂ_T
        while( -1 != geometry->WhetherAngleIsPlusOrMinus(
            result[ count + 0 ],
            result[ count - 1 ],
            result[ i ]
        ) )
        {
            count--;

            if( count == 0 )
            {
                // T𒆒f
                break;

                /// @note
                /// G[̂߂ɍlĂ@łA
                /// ̏ɂ͖肪ƎvB
            }
        }
        count++;

        // Q_
        Point::Swap( result[ count ], result[ i ] );
    }


    // z̑傫A_Ɠɂ
    Array::Resize( result, count );

    return result;


// [ Reference ]ubŏASYvDcPY(TCGX) P135
}


/// ɂ_̃CfbNX擾 (YɍŏAXɍő̈ʒu̓_)
int Geometry::GetIndexOfPointInCorner( Points^ point )
{
    /// @note vfO͓ʂȈӖ߁AȓΏۂƂȂ

    int result = 1;

    // YɍŏƂȂ_T (ŏ̓_mrKv͂Ȃ̂ŁA̗̎vfn߂Ă)
    for( int i=result + 1; i < point->Length; i++ )
    {
        if( point[ i ].Y < point[ result ].Y )
        {
            result = i;
        }
    }

    // ... ̓_YWv_ɂ XɍőƂȂ_T
    for( int i=1; i < point->Length; i++ )
    {
        if( ( Math::Abs( point[ i ].Y - point[ result ].Y ) < Double::Epsilon )
            && ( point[ result ].X < point[ i ].X ) )
        {
            result = i;
        }
    }
    return result;

// [ Reference ]ubŏASYvDcPY(TCGX) P135
}


/// px̊Ԃ̑召֌W̔s W擾
double Geometry::GetCoefficientComparisonOfAngle( Point point1, Point point2 )
{
    // Q_Ԃ̋߂
    Point distance = point2 - point1;


    double result = 0.0;

    if( Double::Epsilon <= Math::Abs( distance.X )
     || Double::Epsilon <= Math::Abs( distance.Y ) )
    {
        // X̋܂Y̋ [ł͂Ȃ
        result = distance.Y / ( Math::Abs( distance.X ) + Math::Abs( distance.Y ) );
    }

    if( distance.X < 0.0 )
    {
        // X̋ƂȂĂ (̒萔̈Ӗ͕s)
        result = 2.0 - result;
    }
    else if( distance.Y < 0.0 )
    {
        // Y̋ƂȂĂ (̒萔̈Ӗ͕s)
        result = result + 4.0;
    }

    result *= 90.0;
    /// @note ̌vZ̈Ӗ͕s


    // W͈̔͂mF (eLXgŎẮ͈B͕s)
    Debug::Assert( 0.0 <= result && result <= 360.0, "ʂ͔͈͓ɂ" );

    return result;


// [ Reference ]ubŏASYvDcPY(TCGX) P132
}


/// R_̂Ȃpx͐H
int Geometry::WhetherAngleIsPlusOrMinus( Point middle, Point left, Point right )
{
    // [̓_̋߂
    Point d1 = right - left;

    // [ƒ̓_Ƃ̋߂
    Point d2 = middle - left;


    double area1 = d1.X * d2.Y;
    double area2 = d1.Y * d2.X;

    if( area1 > area2 )
    {
        return +1;
    }

    if( area1 < area2 )
    {
        return -1;
    }

    if( ( d1.X * d2.X < 0.0 ) || ( d1.Y * d2.Y < 0.0 ) )
    {
        return -1;
    }

    if( ( ( d1.X * d1.X ) + ( d1.Y * d1.Y ) ) < ( ( d2.X * d2.X ) + ( d2.Y * d2.Y ) ) )
    {
        return +1;
    }

    // {ƂȂ_ Q_̒ɂ
    return 0;


// [ Reference ]ubŏASYvDcPY(TCGX) P127
}

/// _Ɛ̋߂
double Geometry::CalculateDistanceOfPointAndSegment( Point point, Segment segment )
{
    if( segment.IsSamePoint() )
    {
        // _([_)Ȃ Ɠ_Ƃ̋Ԃ
        return Point::CalculateDistance( segment.Point1, point );
    }


    Point dPoint = segment.Point2 - segment.Point1;
    Point origin = segment.Point1 - point;

    double a = ( dPoint.X * dPoint.X ) + ( dPoint.Y * dPoint.Y );
    double b = ( dPoint.X * origin.X ) + ( dPoint.Y * origin.Y );

    // }ϐ߂
    double parameter = -( b / a );

    /// @note
    /// }ϐOP͈̔͂ɉނƂŁȂ͈̔͊OɂȂƂ
    /// ̒[ɍ킹邱ƂłB

    if( parameter < 0.0 ) parameter = 0.0;
    if( parameter > 1.0 ) parameter = 1.0;


    // ̑߂
    Point perpendicular = segment.Point1 + ( parameter * dPoint );

    // ... Ɠ_Ƃ̋߂
    return Point::CalculateDistance( perpendicular, point );


// [ Reference ] ToyWiki - Ɠ_̋ ( http://toycode.com/toywiki/pages/_E7B79AE58886E381A8E782B9E381AEE8B79DE99BA2_.html )
}


/// p`̓H
bool Geometry::IsInsideOfPolygon( Points^ vertices, Point target )
{
    int vertexSum = vertices->Length;   // _
    Debug::Assert( 3 <= vertexSum, "_͂Rȏł (ȂΑp`ƂȂ蓾Ȃ)" );


    // Zp _̔z𐶐
    Points^ points = gcnew Points( vertexSum + 2 );

    // ... z̑O󂯂悤ɃRs[
    Array::Copy(
        vertices,   // Rs[
        0,          // Rs[JnCfbNX
        points,     // Rs[
        1,          // i[JnCfbNX
        vertexSum   // Rs[vf̐
    );

    // ŏ Ō̒_i[
    points[ 0 ] = vertices[ vertexSum - 1 ];

    // Ō ŏ̒_i[
    points[ vertexSum + 1 ] = vertices[ 0 ];


    int crossingCount = 0;      // 
    Point point = points[ 0 ];  // _

    // 􉽊wNX𐶐
    Geometry^ geometry = gcnew Geometry();

    // ΏۂƂ_ Xƕsɐ̕֌ `
    Segment halfLine( target, Point( Double::MaxValue, target.Y ) );


    for( int i=1; i<=vertexSum; i++ )
    {
        // p`̒_ 傫[̐`
        Segment segment( points[ i ], points[ i ] );

        if( !geometry->IsSegmentIntersect( segment, halfLine ) )
        {
            // ꂪƌȂȂ΁Ä[`Ȃ
            segment.Point2 = point;

            // ... _ ΏۂƂĂ钸_ɒ`Ȃ
            point = points[ i ];

            if( geometry->IsSegmentIntersect( segment, halfLine ) )
            {
                // ƌȂ΁AJEg
                crossingCount++;
            }
        }
    }

    // ̓_Ȃ _ɂƔf
    return( crossingCount & 1 );

// [ Reference ]ubŏASYvDcPY(TCGX) P129
}


/// ͌邩H
bool Geometry::IsSegmentIntersect( Segment segment1, Segment segment2 )
{
    int case1 = WhetherAngleIsPlusOrMinus( segment1.Point1, segment1.Point2, segment2.Point1 )
              * WhetherAngleIsPlusOrMinus( segment1.Point1, segment1.Point2, segment2.Point2 );

    int case2 = WhetherAngleIsPlusOrMinus( segment2.Point1, segment2.Point2, segment1.Point1 )
              * WhetherAngleIsPlusOrMinus( segment2.Point1, segment2.Point2, segment1.Point2 );


    return ( case1 <= 0 ) && ( case2 <= 0 );

// [ Reference ]ubŏASYvDcPY(TCGX) P128
}

/// NCbN\[g
void Geometry::QuickSort( int leftEdge, int rightEdge, array< double >^ reference, Points^% points )
{
    Debug::Assert( reference->Length == points->Length, "QƒlƓ_͈̐vĂ" );


    // l(Ԃ̒̒l) ߂
    const double standardValue = reference[ ( leftEdge + rightEdge ) / 2 ];

    int left = leftEdge;
    int right = rightEdge;

    while( left <= right )
    {
        // Ԃ̍[ l傫Ȃ̂
        while( reference[ left ] < standardValue )
        {
            left++;
        }

        // Ԃ̉E[ l菬Ȃ̂
        while( reference[ right ] > standardValue )
        {
            right--;
        }

        if( left <= right )
        {
            // Q_
            Point::Swap( points[ left ], points[ right ] );

            // ... \[g̎Qƒl
            Swap( reference[ left ], reference[ right ] );

            left++;
            right--;
        }
    }


    // Ԃ̍[ɒB܂ Ԃ
    if( leftEdge < right )
    {
        QuickSort( leftEdge, right, reference, points );
    }

    // Ԃ̉E[ɒB܂ 
    if( left < rightEdge )
    {
        QuickSort( left, rightEdge, reference, points );
    }


// [ Reference ]ubŏASYvDcPY(TCGX) P135
}


/// Q̒l
void Geometry::Swap( double% left, double% right )
{
    double swap = left;

    left = right;
    right = swap;
}