#include "Matrix.h"


#include "Vector.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// w肳ꂽ傫Ő sŏ [ Constructor ]
Matrix::Matrix( int row, int column )
{
    // ̈mۂ
    SecureDomain( row );

    for( int m=0; m<row; m++ )
    {
        // ... ̃xNg𐶐
        m_rowVectors[ m ] = gcnew Vector( column );
    }

#ifdef _DEBUG
    for( int m=0; m<Row; m++ )
    {
        Debug::Assert(
            m_rowVectors[ m ]->IsZeroVector(),
            "sɏĂ"
        );
    }

    /// @note
    /// s̔s֐́Arpɗs쐬Ƃ
    /// ̃RXgN^ĂяoBāAł̊֐Ăяo
    /// ċAĂ܂B

#endif
}

/// Rs[Ɠ傫Ő ̍sxNgŏ [ Copy constructor ]
Matrix::Matrix( Matrix^ other )
{
    // ̈mۂ
    SecureDomain( other->Row );

    // (sxNg̎)ݒ肷
    for( int m=0; m < other->Row; m++ )
    {
        // ... sxNg̃Rs[Ő
        m_rowVectors[ m ] = gcnew Vector( other->m_rowVectors[ m ] );
    }
}


/// w肳ꂽsŗ̈mۂ
void Matrix::SecureDomain( int row )
{
    /// @note
    /// ł́AsxNg̗̈mۂ邾łB
    /// ̌ɍsxNg̃CX^X𐶐KvB


    Debug::Assert( 1 <= row , "s͂Pȏł" );


    // ̈sxNgƂĊmۂ
    m_rowVectors = gcnew array< Vector^ >( row );


    /// @note
    /// C++ ̕@Az̏ŃftHgRXgN^ȊO
    /// ĂяoƂ͂łȂ߁AsƗ𕪂ďĂB
}

/// s̑傫ݒ肷
void Matrix::SetSize( int row, int column )
{
    Debug::Assert( ( row != Row ) || ( column != Column ), "s܂͗񐔂͕ύX" );


    // ̈
    delete m_rowVectors;


    // ... ̈mۂ
    SecureDomain( row );

    for( int m=0; m<row; m++ )
    {
        // ... ̃xNg𐶐
        m_rowVectors[ m ] = gcnew Vector( column );
    }
}


/// Indexer [ Property ]
Vector^ Matrix::default::get( int index )
{
    Debug::Assert( ( 0 <= index ) && ( index <= Row ), "Y͍s͈͓̔ł" );

    // YPƂ邽߂ɁA␳Ďw肷
    return m_rowVectors[ index - 1 ];
}

/// 񐔂擾 [ Property ]
int Matrix::Column::get()
{
    // sxNg̎擾
    return m_rowVectors[ 0 ]->Dimension;
}


/// a += [ Operator Overloading ]
Matrix^ Matrix::operator+=( Matrix^ obj )
{
    Debug::Assert( IsEqualSize( obj ), "̍sƑ傫͓" );


    for( int m=0; m<Row; m++ )
    {
        m_rowVectors[ m ] += obj->m_rowVectors[ m ];
    }
    return this;
}

///  -= [ Operator Overloading ]
Matrix^ Matrix::operator-=( Matrix^ obj )
{
    Debug::Assert( IsEqualSize( obj ), "̍sƑ傫͓" );


    for( int m=0; m<Row; m++ )
    {
        m_rowVectors[ m ] -= obj->m_rowVectors[ m ];
    }
    return this;
}

/// XJ[ *= [ Operator Overloading ]
Matrix^ Matrix::operator*=( double val )
{
    for(int m=0; m<Row; m++ )
    {
        m_rowVectors[ m ] *= val;
    }
    return this;
}

/// s *= [ Operator Overloading ]
Matrix^ Matrix::operator*=( Matrix^ obj )
{
    // s (operator*)Ăяo
    Matrix^ result = this * obj;

    for( int m=0; m<Row; m++ )
    {
        // sxNgACX^XƂăRs[
        m_rowVectors[ m ] = gcnew Vector( result->m_rowVectors[ m ] );
    }

    return this;
}

/// s̘a [ Operator Overloading ]
Matrix^ Matrix::operator+( Matrix^ left, Matrix^ right )
{
    Matrix^ result = gcnew Matrix( left );
    result += right;

    return result;
}

/// s̍ [ Operator Overloading ]
Matrix^ Matrix::operator-( Matrix^ left, Matrix^ right )
{
    Matrix^ result = gcnew Matrix( left );
    result -= right;

    return result;
}


/// sƃxNg̐ [ Operator Overloading ]
Vector^ Matrix::operator*( Matrix^ matrix, Vector^ vector )
{
    /// @note
    /// ł́AsxNgxNgƌȂČvZĂ


    Debug::Assert(
        matrix->Column == vector->Dimension,
        "s̗񐔂ƃxNg͓̎"
    );


    Vector^ result = gcnew Vector( matrix->Row );

    for( int m=1; m<=matrix->Row; m++ )
    {
        // sƂɁAxNg̐Ƃ̐ς̑a߂
        double sum = 0.0;

        for( int n=1; n<=matrix->Column; n++ )
        {
            sum += matrix[ m ][ n ] * vector[ n ];
        }
        result[ m ] = sum;
    }

    // 덷
    result->RemoveErrorComponent();

    return result;
}

/// xNgƍs̐ [ Operator Overloading ]
Vector^ Matrix::operator*( Vector^ vector, Matrix^ matrix )
{
    Debug::Assert(
        vector->Dimension == matrix->Column,
        "xNg̎ƍs̗񐔂͓"
    );


    Vector^ result = gcnew Vector( matrix->Column );

    for( int n=1; n<=matrix->Column; n++ )
    {
        // 񂲂ƂɁAxNg̐Ƃ̐ς̑a߂
        double sum = 0.0;

        for( int m=1; m<=matrix->Row; m++ )
        {
            sum += vector[ m ] * matrix[ m ][ n ];
        }
        result[ n ] = sum;
    }

    // 덷
    result->RemoveErrorComponent();

    return result;
}

/// s [ Operator Overloading ]
Matrix^ Matrix::operator*( Matrix^ left, Matrix^ right )
{
    Debug::Assert(
        left->Column == right->Row,
        "sleft ̗񐔂ƍsright ̍s͓"
    );

    Matrix^ result = gcnew Matrix( left->Row, right->Column );

    // sxNg x s
    for( int m=1; m <= left->Row; m++ )
    {
        for( int r=1; r <= right->Column; r++ )
        {
            double sum = 0.0;
            for( int n=1; n <= left->Column; n++ )
            {
                sum += left[ m ][ n ] * right[ n ][ r ];
            }
            result[ m ][ r ] = sum;
        }
    }

    // 덷
    result->RemoveErrorComponent();

    return result;
}


/// Zq == [ Operator Overloading ]
bool Matrix::operator==( Matrix^ left, Matrix^ right )
{
    // x vZ@CvVƂĔr
    return left->Equals( right, Double::Epsilon );
}

/// sZq != [ Operator Overloading ]
bool Matrix::operator!=( Matrix^ left, Matrix^ right )
{
    // l̓̔ےԂ
    return !left->Equals( right, Double::Epsilon );
}

/// l̓mF
bool Matrix::Equals( Matrix^ obj )
{
    // x vZ@CvVƂĔr
    return Equals( obj, Double::Epsilon );
}

/// l̓mF
bool Matrix::Equals( Matrix^ obj, double precision )
{
    // NULLƂ͓ł͂Ȃ
    if( safe_cast< System::Object^ >( obj ) == nullptr ) return false;

    Debug::Assert( IsEqualSize( obj ), "̍sƑ傫͓" );


    for( int m=0; m<Row; m++ )
    {
        // sxNgƂɁAxw肵Ĕr
        if( !m_rowVectors[ m ]->Equals( obj->m_rowVectors[ m ], precision ) )
        {
            return false;
        }
    }
    return true;
}


/// sɂ
void Matrix::ZeroMatrix()
{
    // SĂ̍sxNgxNgɂ
    for( int m=0; m<Row; m++ )
    {
        m_rowVectors[ m ]->ZeroVector();
    }
}

/// Pʍsɂ
void Matrix::UnitMatrix()
{
    Debug::Assert( IsSquareMatrix(), "sł" );

    for( int n=1; n<=Column; n++ )
    {
        for( int m=1; m<=Row; m++ )
        {
            // ΊpȂ1.0 ȊO0.0 Ƃ
            this[ m ][ n ] = ( m == n )? 1.0 : 0.0;
        }
    }
}

/// ]usԂ
Matrix^ Matrix::TransposedMatrix()
{
    // sƗ񐔂𔽓]s쐬
    Matrix^ result = gcnew Matrix( Column, Row );

    for( int n=1; n<=Column; n++ )
    {
        for( int m=1; m<=Row; m++ )
        {
            // sƗ𔽓]đ
            result[ n ][ m ] = this[ m ][ n ];
        }
    }
    return result;
}


/// ts߂
bool Matrix::InverseMatrix( Matrix^% result )
{
    Debug::Assert( IsSquareMatrix(), "sł" );


    // Zp̍s𐶐
    Matrix^ matrix = gcnew Matrix( this );

    array< int >^ informationToChangeRow;   // s̏

    // kt
    if( !matrix->LuDecomposition( informationToChangeRow ) )
    {
        // ktłȂȂ 𒆎~
        return false;
    }


    // gƓ傫 ʊi[p̍s𐶐
    result = gcnew Matrix( Row, Column );

    for( int n=1; n<=Row; n++ )
    {
        // ŏ̍s ̍s܂
        for( int m=1; m<=Row; m++ )
        {
            const int row = informationToChangeRow[ m ];

            double component = ( row == n )? 1.0 : 0.0;

            for( int i=1; i<m; i++ )
            {
                // ̍s̗ƌʂƂȂs̍s ̐ς
                component -= matrix[ row ][ i ] * result[ i ][ n ];
            }
            result[ m ][ n ] = component;
        }

        //  ŏ̍s܂
        for( int m=Row; m>=1; m-- )
        {
            const int row = informationToChangeRow[ m ];

            double component = result[ m ][ n ];

            for( int i=m+1; i<=Row; i++ )
            {
                // ̍s̗ƌʂƂȂs̍s ̐ς
                component -= matrix[ row ][ i ] * result[ i ][ n ];
            }
            result[ m ][ n ] = component / matrix[ row ][ m ];
        }
    }
    return true;


// [ Reference ]ubɂŐVASYTvF(Zp]_) P40
}


/// kt (sOps(Lower)ƏOps(Upper) ɕ)
bool Matrix::LuDecomposition( array< int >^% informationToChangeRow )
{
    Debug::Assert( informationToChangeRow == nullptr, "ʂi[ ĂȂ̂ł" );
    Debug::Assert( IsSquareMatrix(), "sł" );


    // s̏𐶐
    informationToChangeRow = gcnew array< int >( Row + 1 );

    // ... 
    for( int n=1; n<=Row; n++ )
    {
        informationToChangeRow[ n ] = n;
    }


    // esɂ Βlő̐擾
    array< double >^ maxAbsolutes = GetComponentWithMaximumAbsoluteValue();

    for( int n=1; n<=Row; n++ )
    {
        if( maxAbsolutes[ n ] == 0.0 )
        {
            // ő̐[̍s(xNg)܂ނȂ kt͂łȂ
            return false;
        }
    }


    for( int n=1; n<=Row; n++ )
    {
        int maxRow = Row;   // ő̍s

        double max = Double::MinValue;

        for( int m=n; m<=Row; m++ )
        {
            // s艺ɂ Βl̍ő̋t x Βl ő̍s߂
            const int row = informationToChangeRow[ m ];

            double component = maxAbsolutes[ row ] * Math::Abs( this[ row ][ n ] );

            if( max < component )
            {
                max = component;
                maxRow = m;
            }
        }

        const int currentRow = informationToChangeRow[ maxRow ];    // ݂̍s

        if( maxRow != n )
        {
            // ݂̍sőłȂ sԍ
            informationToChangeRow[ maxRow ] = informationToChangeRow[ n ];
            informationToChangeRow[ n ] = currentRow;
        }

        const double diagonalComponent = this[ currentRow ][ n ];   // Ίp

        if( Math::Abs( diagonalComponent ) < Double::Epsilon )
        {
            // Ίp[Ȃ kt͂łȂ
            return false;
        }

        // Gauss @
        for( int m=n+1; m<=Row; m++ )
        {
            const int row = informationToChangeRow[ m ];

            this[ row ][ n ] /= diagonalComponent;

            for( maxRow=n+1; maxRow<=Row; maxRow++ )
            {
                this[ row ][ maxRow ] -= this[ row ][ n ] * this[ currentRow ][ maxRow ];
            }
        }
    }
    return true;


// [ Reference ]ubɂŐVASYTvF(Zp]_) P387
}

/// Βlő̐擾
array< double >^ Matrix::GetComponentWithMaximumAbsoluteValue()
{
    array< double >^ result = gcnew array< double >( Row + 1 );


    // esɂĒׂ
    for( int n=1; n<=Row; n++ )
    {
        double max = 0.0;

        // Βlő̐T
        for( int m=1; m<=Row; m++ )
        {
            const double absolute = Math::Abs( this[ n ][ m ] );

            if( max < absolute )
            {
                // őlXV
                max = absolute;
            }
        }

        // Βlő̐̋t ʂɊi[([ZȂ悤ɂĂ)
        result[ n ] = ( max == 0.0 )? 0.0 : 1.0 / max;
    }
    return result;
}


/// 傫͓H
bool Matrix::IsEqualSize( Matrix^ obj )
{
    return ( Row == obj->Row ) && ( Column == obj->Column);
}

/// s񂩁H
bool Matrix::IsSquareMatrix()
{
    return Row == Column;
}


/// s񂩁H
bool Matrix::IsOrthogonalMatrix( double precision )
{
    Debug::Assert( IsSquareMatrix(), "sł" );

    // rp̓]us쐬
    Matrix^ matrix = TransposedMatrix();

    // ... Ƃ̍sς߂
    matrix *= this;

    // ... ꂪPʍsƂȂĂ邩H
    return matrix->IsUnitMatrix( precision );
}

/// Pʍs񂩁H
bool Matrix::IsUnitMatrix( double precision )
{
    Debug::Assert( IsSquareMatrix(), "sł" );

    // rp̍s쐬
    Matrix^ compare = gcnew Matrix( Row, Column );

    // ... PʍsƂ
    compare->UnitMatrix();

    // ... Ɠr
    return Equals( compare, precision );
}

/// s񂩁H
bool Matrix::IsZeroMatrix()
{
    // rp̗s쐬
    Matrix^ compare = gcnew Matrix( Row, Column );

#ifdef _DEBUG
    for( int m=1; m<=compare->Row; m++ )
    {
        Debug::Assert(
            compare[ m ]->IsZeroVector(),
            "sɏĂ"
        );
    }
#endif

    return ( this == compare );
}


/// 덷 (̏)
void Matrix::RemoveErrorComponent()
{
    double maxOfAbsoluteValue = 0.0;


    for( int m=1; m<=Row; m++ )
    {
        // Βlő̐
        for( int n=1; n<Column; n++ )
        {
            double compare = Math::Abs( this[ m ][ n ] );

            if( maxOfAbsoluteValue < compare )
            {
                maxOfAbsoluteValue = compare;
            }
        }
    }


    if( Double::Epsilon < maxOfAbsoluteValue )
    {
        // ő̐ vZ@CvV傫ΏC
        for( int m=1; m<=Row; m++ )
        {
            for( int n=1; n<Column; n++ )
            {
                // Βlő̐ƔrđΓIɏl [Ƃ
                if( ( Math::Abs( this[ m ][ n ] ) / maxOfAbsoluteValue ) < Tolerance )
                {
                    this[ m ][ n ] = 0.0;
                }
            }
        }
    }

// [ Reference ]ulvZȑOvYamada.K ( http://www.asahi-net.or.jp/~uc3k-ymd/Lesson/Section03/section03_13.html )
}


/// CX^X̐𕶎ŕԂ
System::String^ Matrix::ToString()
{
    String^ result;

    // SẴxNg ƂĘA
    for each( Vector^ vector in m_rowVectors )
    {
        result += vector->ToString() + Environment::NewLine;
    }
    return result;
}