#include "Point.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// [ Constructor ]
Point::Point( double X, double Y ) :
    m_x( X ),
    m_y( Y )
{
}


/// 𔽓]ĕԂ [ Operator Overloading ]
Point Point::operator-()
{
    Point result( -m_x, -m_y );
    return result;
}


/// a += [ Operator Overloading ]
Point Point::operator+=( Point% obj )
{
    m_x += obj.m_x;
    m_y += obj.m_y;

    return *this;
}

///  -= [ Operator Overloading ]
Point Point::operator-=( Point% obj )
{
    m_x -= obj.m_x;
    m_y -= obj.m_y;

    return *this;
}

///  *= [ Operator Overloading ]
Point Point::operator*=( double val )
{
    m_x *= val;
    m_y *= val;

    return *this;
}

///  /= [ Operator Overloading ]
Point Point::operator/=( double val )
{
    m_x /= val;
    m_y /= val;

    return *this;
}


/// a + [ Operator Overloading ]
Point Point::operator+( Point% left, Point% right )
{
    Point result = left;
    result += right;

    return result;
}

///  - [ Operator Overloading ]
Point Point::operator-( Point% left, Point% right )
{
    Point result = left;
    result -= right;

    return result;
}


///  * [ Operator Overloading ]
Point Point::operator*( double val, Point% obj )
{
    Point result = obj;
    result *= val;

    return result;
}

///  * [ Operator Overloading ]
Point Point::operator*( Point% obj, double val )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    return val * obj;
}

///  / [ Operator Overloading ]
Point Point::operator/( Point% obj, double val )
{
    Point result = obj;
    result /= val;

    return result;
}


/// Zq == [ Operator Overloading ]
bool Point::operator==( Point% left, Point% right )
{
    return Math::Abs( left.m_x - right.m_x ) < Double::Epsilon
        && Math::Abs( left.m_y - right.m_y ) < Double::Epsilon;
}

/// sZq != [ Operator Overloading ]
bool Point::operator!=( Point% left, Point% right )
{
    // Z̔ےԂ
    return !( left == right );
}


/// _H
bool Point::IsInOrigin()
{
    return (
        ( Math::Abs( m_x ) < Double::Epsilon ) &&
        ( Math::Abs( m_y ) < Double::Epsilon )
    );
}


/// PointF\̂ LXgĕԂ
System::Drawing::PointF Point::ToPointF()
{
    Drawing::PointF result(
        safe_cast< float >( m_x ),
        safe_cast< float >( m_y )
    );
    return result;
}


/// ߂
double Point::CalculateDistance( Point% left, Point% right )
{
    double dx = left.X - right.X;
    double dy = left.Y - right.Y;

    return Math::Sqrt( dx * dx + dy * dy );

    /// @note O̒藝
}

/// Q̈ʒu
void Point::Swap( Point% left, Point% right )
{
    // Rs[𐶐
    Point swap( left );

    left = right;
    right = swap;
}