#include "PositionVector.h"


#include "Matrix.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// [ Constructor ]
PositionVector::PositionVector() :
    Vector( DefaultDimension )
{
    Debug::Assert( IsInOrigin(), "_ɏĂ" );
}

/// 琶 [ Constructor ]
PositionVector::PositionVector( double x, double y, double z ) :
    Vector( DefaultDimension )
{
    this[ 1 ] = x;
    this[ 2 ] = y;
    this[ 3 ] = z;


    /// @note Cxg𔭐Ȃ߂ɁAvpeBpĂȂ
}

/// 琶 [ Constructor ]
PositionVector::PositionVector( System::Decimal x, System::Decimal y, System::Decimal z ) :
    Vector( DefaultDimension )
{
    this[ 1 ] = Decimal::ToDouble( x );
    this[ 2 ] = Decimal::ToDouble( y );
    this[ 3 ] = Decimal::ToDouble( z );
}

/// xNg琶(mF邽߂ɁAI[o[ChĂ) [ Constructor ]
PositionVector::PositionVector( Vector^ vector ) :
    Vector( vector )
{
    Debug::Assert( Dimension == DefaultDimension, "̎ł" );
}

/// XML琶 [ Constructor ]
PositionVector::PositionVector( System::Xml::XmlElement^ element ) :
    Vector( DefaultDimension )
{
    // vf擾
    Xml::XmlElement^ node = element[ "position" ];

    if( node != nullptr )
    {
        // 擾łȂ΁Aݒ肷
        this[ 1 ] = Double::Parse( node->GetAttribute( "x" ) );
        this[ 2 ] = Double::Parse( node->GetAttribute( "y" ) );
        this[ 3 ] = Double::Parse( node->GetAttribute( "z" ) );
    }
}


/// a + [ Operator Overloading ]
PositionVector^ PositionVector::operator+( PositionVector^ left, PositionVector^ right )
{
    PositionVector^ result = gcnew PositionVector( left );
    result += right;

    return result;
}

/// a + [ Operator Overloading ]
PositionVector^ PositionVector::operator+( PositionVector^ positionVector, Vector^ vector )
{
    Debug::Assert( vector->Dimension == DefaultDimension, "̃xNg ̎ł" );

    PositionVector^ result = gcnew PositionVector( positionVector );
    result += vector;

    return result;
}

/// a + [ Operator Overloading ]
PositionVector^ PositionVector::operator+( Vector^ vector, PositionVector^ positionVector )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    return positionVector + vector;;
}


///  - [ Operator Overloading ]
PositionVector^ PositionVector::operator-( PositionVector^ left, PositionVector^ right )
{
    PositionVector^ result = gcnew PositionVector( left );
    result -= right;

    return result;
}

///  - [ Operator Overloading ]
PositionVector^ PositionVector::operator-( PositionVector^ positionVector, Vector^ vector )
{
    Debug::Assert( vector->Dimension == DefaultDimension, "̃xNg ̎ł" );


    PositionVector^ result = gcnew PositionVector( positionVector );
    result -= vector;

    return result;
}

///  * [ Operator Overloading ]
PositionVector^ PositionVector::operator*( PositionVector^ positionVector, double scalar )
{
    PositionVector^ result = gcnew PositionVector( positionVector );
    result *= scalar;

    return result;
}

///  * [ Operator Overloading ]
PositionVector^ PositionVector::operator*( double scalar, PositionVector^ positionVector )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    return positionVector * scalar;
}

///  * (ʒuxNg]) [ Operator Overloading ]
PositionVector^ PositionVector::operator*( Matrix^ rotationMatrix, PositionVector^ positionVector )
{
    return gcnew PositionVector( rotationMatrix * safe_cast< Vector^ >( positionVector ) );
}


///  / [ Operator Overloading ]
PositionVector^ PositionVector::operator/( PositionVector^ positionVector, double scalar )
{
    PositionVector^ result = gcnew PositionVector( positionVector );
    result /= scalar;

    return result;
}


/// Ẍʒuݒ肷 [ Property ]
void PositionVector::X::set( double value )
{
    if( this[ 1 ] != value )
    {
        // ݂̒lƈقȂȂ΁Aݒ肷
        this[ 1 ] = value;

        // ... l̕ύXCxg𔭐
        ValueChanged( this, gcnew System::EventArgs() );
    }
}

/// Ÿʒuݒ肷 [ Property ]
void PositionVector::Y::set( double value )
{
    if( this[ 2 ] != value )
    {
        // ݂̒lƈقȂȂ΁Aݒ肷
        this[ 2 ] = value;

        // ... l̕ύXCxg𔭐
        ValueChanged( this, gcnew System::EventArgs() );
    }
}

/// Z̈ʒuݒ肷 [ Property ]
void PositionVector::Z::set( double value )
{
    if( this[ 3 ] != value )
    {
        // ݂̒lƈقȂȂ΁Aݒ肷
        this[ 3 ] = value;

        // ... l̕ύXCxg𔭐
        ValueChanged( this, gcnew System::EventArgs() );
    }
}


/// CX^X̐𕶎ŕԂ
String^ PositionVector::ToString()
{
    return String::Format( "{0:0.000} {1:0.000} {2:0.000}", X, Y, Z );
}


/// CX^X̐XMLŕԂ
System::Xml::XmlElement^ PositionVector::ToXml( System::Xml::XmlDocument^ document )
{
    // [g𐶐
    Xml::XmlElement^ root = document->CreateElement( "position" );

    // ... tB[h𑮐ƂĐݒ肷
    root->SetAttribute( "x", X.ToString() );
    root->SetAttribute( "y", Y.ToString() );
    root->SetAttribute( "z", Z.ToString() );

    return root;
}
