#include "Vector.h"


#include "Matrix.h"


using namespace Robotics;
using namespace System;
using namespace System::Diagnostics;


/// w肳ꂽŐ xNgŏ [ Constructor ]
Vector::Vector( int dimension )
{
    // ̈mۂ
    SecureDomain( dimension );

    Debug::Assert( Dimension == dimension, "͎wlɐݒ肳Ă" );

#ifdef _DEBUG
    for( int i=0; i<Dimension; i++ )
    {
        Debug::Assert( m_components[ i ] == 0.0, "xNgɏĂ" );
    }

    /// @note
    /// xNg̔s֐́ArpɗxNg쐬Ƃ
    /// ̃RXgN^ĂяoBāAł̊֐Ăяo
    /// ċAĂ܂B

#endif
}

/// w肳ꂽŐ ̔zŏ [ Constructor ]
Vector::Vector( const double* val, int dimension )
{
    // ̈mۂ
    SecureDomain( dimension );

    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] = val[ i ];
    }

    Debug::Assert( Dimension == dimension, "͎wlɐݒ肳Ă" );
}

/// Rs[ƓŐ ̐ŏ [ Copy constructor ]
Vector::Vector( Vector^ other )
{
    // ̈mۂ
    SecureDomain( other->Dimension );

    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] = other->m_components[ i ];
    }

    Debug::Assert( Dimension == other->Dimension, "̓Rs[Ɠɐݒ肳Ă" );
}


/// w肳ꂽŗ̈mۂ
void Vector::SecureDomain( int dimension )
{
    Debug::Assert( 1 <= dimension, "͎Rł" );

    // ̈mۂ
    m_components = gcnew array< double >( dimension );
}


/// Indexer [ Property ]
double Vector::default::get( int index )
{
    Debug::Assert( IsRangeOfDimension( index ), "Y͎͈͓̔ł" );

    // YPƂȂ悤ɁA␳Ďw肷
    return m_components[ index - 1 ];
}

/// Indexer [ Property ]
void Vector::default::set( int index, double value )
{
    Debug::Assert( IsRangeOfDimension( index ), "Y͎͈͓̔ł" );

    // YPƂȂ悤ɁA␳Ďw肷
    m_components[ index - 1 ] = value;
}


/// ݒ肷 [ Property ]
void Vector::Dimension::set( int value )
{
    Debug::Assert( value != Dimension, "͕ύX" );


    // ̈
    delete[] m_components;

    // ... w肳ꂽŗ̈mۂ
    SecureDomain( value );

    Debug::Assert( Dimension == value, "͎wlɐݒ肳Ă" );
}


/// txNgԂ [ Operator Overloading ]
Vector^ Vector::operator-()
{
    return gcnew Vector( -1.0 * this );
}


/// a += [ Operator Overloading ]
Vector^ Vector::operator+=( Vector^ obj )
{
    Debug::Assert( Dimension == obj->Dimension, "̃xNgƎ͓" );


    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] += obj->m_components[ i ];
    }
    return this;
}

///  -= [ Operator Overloading ]
Vector^ Vector::operator-=( Vector^ obj )
{
    Debug::Assert( Dimension == obj->Dimension, "̃xNgƎ͓" );


    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] -= obj->m_components[ i ];
    }
    return this;
}

///  *= [ Operator Overloading ]
Vector^ Vector::operator*=( double val )
{
    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] *= val;
    }
    return this;
}

///  /= [ Operator Overloading ]
Vector^ Vector::operator/=( double val )
{
    Debug::Assert( Double::Epsilon <= Math::Abs( val ), "̓[ł͂Ȃ ([Z̖h~)" );


    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] /= val;
    }
    return this;
}

/// Zq == [ Operator Overloading ]
bool Vector::operator==( Vector^ left, Vector^ right )
{
    // x vZ@CvVƂĔr
    return left->Equals( right, Double::Epsilon );
}

/// sZq != [ Operator Overloading ]
bool Vector::operator!=( Vector^ left, Vector^ right )
{
    // l̓̔ےԂ
    return !left->Equals( right, Double::Epsilon );
}

/// l̓mF
bool Vector::Equals( Vector^ obj )
{
    // x vZ@CvVƂĔr
    return Equals( obj, Double::Epsilon );
}

/// l̓mF
bool Vector::Equals( Vector^ obj, double precision )
{
    // NULLƂ͓ł͂Ȃ
    if( safe_cast< System::Object^ >( obj ) == nullptr ) return false;

    Debug::Assert( Dimension == obj->Dimension, "̃xNgƎ͓" );


    for( int i=0; i<Dimension; i++ )
    {
        // e̍̐Βl߂
        double remainder = Math::Abs( m_components[ i ] - obj->m_components[ i ] );

        // ... 𐸓x(덷̗L͈)Ɣr
        if( precision < remainder )
        {
            return false;
        }
    }
    return true;
}

/// xNg̘a [ Operator Overloading ]
Vector^ Vector::operator+( Vector^ left, Vector^ right )
{
    Vector^ result = gcnew Vector( left );
    result += right;

    return result;
}

/// xNg̍ [ Operator Overloading ]
Vector^ Vector::operator-( Vector^ left, Vector^ right )
{
    Vector^ result = gcnew Vector( left );
    result -= right;

    return result;
}

/// XJ[{ ( x xNg) [ Operator Overloading ]
Vector^ Vector::operator*( double scalar, Vector^ obj )
{
    Vector^ result = gcnew Vector( obj );
    result *= scalar;

    return result;
}

/// XJ[{ (xNg x ) [ Operator Overloading ]
Vector^ Vector::operator*( Vector^ obj, double scalar )
{
    // ̏ւāAI[o[[hĂ铯֐Ăяo
    return scalar * obj;
}

/// XJ[ (xNg / ) [ Operator Overloading ]
Vector^ Vector::operator/( Vector^ obj, double scalar )
{
    Vector^ result = gcnew Vector( obj );
    result /= scalar;

    return result;
}


/// ςԂ
double Vector::InnerProduct( Vector^ left, Vector^ right )
{
    Debug::Assert(
        left->Dimension == right->Dimension,
        "̂Q̃xNg͓̎"
    );

    double result = 0.0;

    // SĂ̐̐ς̘a߂
    for( int i=1; i <= left->Dimension; i++ )
    {
        result += left[ i ] * right[ i ];
    }
    return result;
}


/// OςԂ
Vector^ Vector::CrossProduct( Vector^ left, Vector^ right )
{
    Debug::Assert(
        ( left->Dimension == 3 ) && ( right->Dimension == 3 ),
        "Q̃xNg͂Rł"
    );

    Vector^ result = gcnew Vector( 3 );

    result[ 1 ] = ( left[ 2 ] * right[ 3 ] ) - ( left[ 3 ] * right[ 2 ] );
    result[ 2 ] = ( left[ 3 ] * right[ 1 ] ) - ( left[ 1 ] * right[ 3 ] );
    result[ 3 ] = ( left[ 1 ] * right[ 2 ] ) - ( left[ 2 ] * right[ 1 ] );

    return result;


// [ Reference ]uq[}mCh{bgvcGi(I[) P29
// [ Reference ]u{bgb_vgPv(Ri) P52
}


/// Q̃xNg
Vector^ Vector::Combine( Vector^ left, Vector^ right )
{
    // Q̃xNg̘̎a xNg̎Ƃ
    int dimension = left->Dimension + right->Dimension;

    Vector^ result = gcnew Vector( dimension );


    int index = 1;

    // ̃xNg
    for( int i=1; i <= left->Dimension; i++ )
    {
        result[ index++ ] = left[ i ];
    }

    // ẼxNg
    for( int i=1; i <= right->Dimension; i++ )
    {
        result[ index++ ] = right[ i ];
    }
    return result;
}


/// xNgɂ
void Vector::ZeroVector()
{
#ifdef _DEBUG
    int counter;

    for( counter=0; counter<Dimension; counter++ )
    {
        if( m_components[ counter ] != 0.0 ) break; }
//  } cope with NCover

    Debug::Assert(
        counter <= Dimension,
        "SĂ̐̓[ł͂Ȃ(xNgł͂Ȃ)B"
        "ʂȏsĂ̂ŁAC"
    );
#endif

    for( int i=0; i<Dimension; i++ )
    {
        m_components[ i ] = 0.0;
    }
}

/// ЂݑΏ̍s (s) Ԃ
Matrix^ Vector::SkewSymmetricMatrix()
{
    Debug::Assert( Dimension == 3, "Rł" );

    Matrix^ result = gcnew Matrix( Dimension, Dimension );

    result[ 1 ][ 1 ] = 0.0;
    result[ 2 ][ 2 ] = 0.0;
    result[ 3 ][ 3 ] = 0.0;

    result[ 3 ][ 2 ] = this[ 1 ];
    result[ 1 ][ 3 ] = this[ 2 ];
    result[ 2 ][ 1 ] = this[ 3 ];

    result[ 2 ][ 3 ] = -this[ 1 ];
    result[ 3 ][ 1 ] = -this[ 2 ];
    result[ 1 ][ 2 ] = -this[ 3 ];

    return result;


// [ Reference ]uq[}mCh{bgvcGi(I[) P32
// [ Reference ]u{bgb_vgPv(Ri) P62
}


/// m (xNgԂɂ钷) Ԃ
double Vector::Norm()
{
    double result = 0.0;

    // SĂ̐̓a߂
    for( int i=0; i<Dimension; i++ )
    {
        result += m_components[ i ] * m_components[ i ];
    }

    // ... ̕Ԃ
    return Math::Sqrt( result );


// [ Reference ]uHwul̐`㐔v@Y(w) P105
}


/// PʃxNgH
bool Vector::IsUnitVector( double precision )
{
    Debug::Assert( Dimension <= 3, "R܂łKpłȂ" );

    double result = 0.0;

    // Qa߂
    for( int i=0; i<Dimension; i++ )
    {
        result += m_components[ i ] * m_components[ i ];
    }

    // ... ̐̕ΒlAL͈(x)ǂŔ肷
    return Math::Abs( Math::Sqrt( result ) - 1.0 ) < precision;
}

/// xNgH
bool Vector::IsZeroVector()
{
    // rp̗xNg쐬 (쐬ɗxNgɏ)
    Vector^ zeroVector = gcnew Vector( Dimension );

    return ( this == zeroVector );
}


/// 덷 (̏)
void Vector::RemoveErrorComponent()
{
    double maxOfAbsoluteValue = 0.0;

    // Βlő̐
    for( int i=0; i<Dimension; i++ )
    {
        double compare = Math::Abs( m_components[ i ] );

        if( maxOfAbsoluteValue < compare )
        {
            maxOfAbsoluteValue = compare;
        }
    }


    if( Double::Epsilon < maxOfAbsoluteValue )
    {
        // ő̐ vZ@CvV傫ΏC
        for( int i=0; i<Dimension; i++ )
        {
            // Βlő̐ƔrđΓIɏl [Ƃ
            if( ( Math::Abs( m_components[ i ] ) / maxOfAbsoluteValue ) < Tolerance )
            {
                m_components[ i ] = 0.0;
            }
        }
    }

// [ Reference ]ulvZȑOvYamada.K ( http://www.asahi-net.or.jp/~uc3k-ymd/Lesson/Section03/section03_13.html )
}


/// ͈͓̔H
bool Vector::IsRangeOfDimension( int index )
{
    const int baseNumberOfSuffix = 1;   // Y̊Jnԍ

    return ( index >= baseNumberOfSuffix )
        && ( index <= baseNumberOfSuffix + Dimension );
}


/// CX^X̐𕶎ŕԂ
System::String^ Vector::ToString()
{
    String^ result;

    // SĂ̐ ƂĘA
    for each( double value in m_components )
    {
        result += value.ToString( "0.0000000" ) + " ";
    }
    return result;
}